'use client'
import { useMutation } from '@tanstack/react-query'
import { UserAdd } from './types'
import { toISOIfNotZ } from '@/lib/utils'

const fetchGraphQlUsersAdd = async (record: UserAdd): Promise<{ data: UserAdd | null; status: number }> => {
    console.log('Fetching test data from local API');
    record.expiryStarts = toISOIfNotZ(record.expiryStarts);
    record.expiryEnds = toISOIfNotZ(record.expiryEnds);
    try {
        const res = await fetch('/api/users/add', { method: 'POST', cache: 'no-store', credentials: "include", body: JSON.stringify(record) });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json();
        return { data: data.data, status: res.status }
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

export function useAddUserMutation() {
    return useMutation({
        mutationFn: (data: UserAdd) => fetchGraphQlUsersAdd(data),
        onSuccess: () => { console.log("User created successfully") },
        onError: (error) => { console.error("Create user failed:", error) },
    })
}
